//========================================================
//HI-MD Renderer Application - Random window utility functions
//
//Written by Mark Collier.
//http://www.marcnetsystem.co.uk/
//
//This program is freeware and may be distributed in part or 
//in whole as long as a the author is credited clearly some way in 
//both the source code and in some visible way when the program 
//is running (eg:in a help screen or version info screen ).

//This notice must also appear in any source file that contains
//any part of the code in this file. 

//I (the author) take no responsability for the loss, transfer, corruption
//duplication, modification, or addition of legal or illegal data in any way. 
//
//Thanks for reading

//MarC
//=========================================================
#include <windows.h>
#include "internal.h"

//====================== Internal callbacks =====================
static UINT CALLBACK OFNHookProcOldStyle(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	return DefWindowProc(hWnd, message, wParam, lParam);
}


//=========================== MISC EXPORTED API ========================

BOOL GetInputFileFromAWindow(LPSTR lpstrinfile,DWORD dwBufLen)
{
	OPENFILENAME ofnOpen;
	char szcTitle[MAX_PATH];
	BOOL bRes;
	
	memset(&ofnOpen,0,sizeof(OPENFILENAME));
	memset(lpstrinfile,0,dwBufLen);
	ofnOpen.lStructSize = sizeof(OPENFILENAME);
	ofnOpen.hwndOwner = NULL;
	ofnOpen.hInstance = 0;
	ofnOpen.lpstrFile = lpstrinfile;
	ofnOpen.lpstrFilter = TEXT("OMA File (*.oma)\0*.oma\0OMG file\0*.omg\0All files (*.*)\0*.*\0\0");
	ofnOpen.lpstrFileTitle = szcTitle;
	ofnOpen.lpstrCustomFilter = NULL;
	ofnOpen.nFilterIndex = 1;
	ofnOpen.lpstrInitialDir = NULL;
	ofnOpen.lpstrTitle = "Select oma / omg file to convert.\0";
	ofnOpen.lpstrDefExt = "*.mp3\0";
	ofnOpen.nMaxFile          = dwBufLen - 1 ;
	ofnOpen.nMaxFileTitle     = _MAX_PATH ;
	ofnOpen.Flags = OFN_FILEMUSTEXIST | OFN_ALLOWMULTISELECT | OFN_EXPLORER;
	ofnOpen.lpfnHook = OFNHookProcOldStyle;
	bRes = GetOpenFileName(&ofnOpen);



	return bRes;
}


BOOL GetSaveFileFromAWindow(LPSTR lpstrinfile,DWORD dwBufLen)
{
	OPENFILENAME ofnOpen;
	char szcFilename[MAX_PATH];
	char szcTitle[MAX_PATH];
	BOOL bRes;
	
	memset(&ofnOpen,0,sizeof(OPENFILENAME));
	memset(szcFilename,0,_MAX_PATH);
	ofnOpen.lStructSize = sizeof(OPENFILENAME);
	ofnOpen.hwndOwner = NULL;
	ofnOpen.hInstance = 0;
	ofnOpen.lpstrFile = szcFilename;
	ofnOpen.lpstrFilter = TEXT("WAV File (*.wav)\0*.wav\0All files (*.*)\0*.*\0\0");
	ofnOpen.lpstrFileTitle = szcTitle;
	ofnOpen.lpstrCustomFilter = NULL;
	ofnOpen.nFilterIndex = 1;
	ofnOpen.lpstrInitialDir = NULL;
	ofnOpen.lpstrTitle = "Select wav file to convert to.\0";
	ofnOpen.lpstrDefExt = "*.mp3\0";
	ofnOpen.nMaxFile          = _MAX_PATH ;
	ofnOpen.nMaxFileTitle     = _MAX_PATH ;
	ofnOpen.Flags = OFN_OVERWRITEPROMPT;
	ofnOpen.lpfnHook = OFNHookProcOldStyle;
	bRes = GetSaveFileName(&ofnOpen);

	if(bRes)
	{
		memset(lpstrinfile,0,dwBufLen);
		strncpy(lpstrinfile,szcFilename,dwBufLen - 1);
	}

	return bRes;
}


